Unit GSR2R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, IIS9R_p, GSU1R_p, UTGS10_p;

procedure GSR2R(var ISEED :Integer; N :Integer; var R :Array of Real;
                var TBL :Array of Real; NX :Integer; var IP :Integer;
                var IERR :Integer);

implementation

procedure GSR2R(var ISEED :Integer; N :Integer; var R :Array of Real;
                var TBL :Array of Real; NX :Integer; var IP :Integer;
                var IERR :Integer);
var
L,J,M,K,KH,I :Integer;
DX :Real;
IOP :Array [0..2] of Integer;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
IERR := 0;
IOP[0] := NX;
IOP[1] := N;
IOP[2] := IP;
if ( IP = 1 ) 
 then goto _1;
IIS9R(TBL[0+1*NX],TBL[0+0*NX],IOP[0],TBL[0+2*NX],IERR);
if ( IERR > 64 ) 
 then goto _9;
IP := 1;
_1:
L := IOP[1];
J := IOP[0];
if ( TBL[0+1*NX] > 0. ) or ( TBL[(J-1)+1*NX] < 1.0 ) 
 then goto _8;
for I:=2 to J do
 begin
  if ( TBL[(I-2)+0*NX] > TBL[(I-1)+0*NX] ) 
   then goto _7;
_2:
 end;
GSU1R(ISEED,IOP[1],R);
M := (IOP[0]+1) div 2;
for I:=1 to L do
 begin
  K := M;
  KH := K-1;
_3:
  if ( R[I-1] >= TBL[(K-1)+1*NX] ) 
   then goto _4;
  KH := (KH div 2)+1;
  K := K-KH;
  goto _3;
_4:
  if ( R[I-1] <= TBL[(K+0)+1*NX] ) 
   then goto _5;
  KH := (KH div 2)+1;
  if ( KH = 2 ) 
   then KH := 1;
  K := K+KH;
  goto _3;
_5:
  DX := (R[I-1]-TBL[(K-1)+1*NX]);
  R[I-1] := ((TBL[(K-1)+4*NX]*DX+TBL[(K-1)+3*NX])*DX+TBL[(K-1)+2*NX])*DX+
  TBL[(K-1)+0*NX];
_6:
 end;
if ( IERR ) < 0
 then goto _9
 else if ( IERR ) > 0
       then goto _9
       else goto _10;
_7:
IERR := 66;
goto _9;
_8:
IERR := 67;
_9:
UTGS10(IERR,4);
_10:
end;

end.
